






          Using Morph: Tutorial Excerpt
          Preliminary. For use with Morph Created: Sun Oct  1 19:39:12 1989

          Copyright 1989 by Garry R. Osgood.

          Permission to  copy without  fee all  or part of this material is
          granted provided that the copies are not made  or distributed for
          direct commercial  advantage, the  copyright notice  and title of
          the manual and its date  of  publication  appear,  and  notice is
          given  that  copying  is  by  prermission  of Garry R. Osgood. To
          otherwise republish this material requires a  fee and/or specific
          permission from Garry R. Osgood.

          Contents:
            1. About This Manual
            2. Tutorial  

          1.0 About This Manual
          1.1 Background
          1.2 Organization
           
          1.1 Background
          A  series   of  structured   drawing  objects   that  depict  the
          transformation of one key object into another is called blending,
          or  morphing,  and  is  a  feature of advanced structured drawing
          programs such  as Adobe  System's Illustrator  88. Artists employ
          blending  for  a  variety  of  purposes: giving rounded objects a
          three  dimensional   effect,   making   in-between   objects  for
          animation, or obtaining subtle variations between objects quickly
          and without tedious manipulation of  control  points  (to  name a
          few). 

          As of  this writing, no version of Illustrator 88 has been ported
          to the Amiga Personal  Computer,  and  Professional  Draw Version
          1.0, by  Gold Disk Inc., the preminent structured drawing program
          in the Amiga community,  has no  blending tool.  Morph, a utility
          program  by  Garry  R.  Osgood,  employs  clip  files  created by
          Professional Draw  to emulate  Illustrator 88's  blend tool. This
          manual teaches  you how  to use Professional Draw in concert with
          Morph so you can enhance your drawing with blending effects. 

          To use this manual, you need:

              An Amiga 500/1000/2000 Personal Computer 
              A copy of Gold Disk's Professional Draw, version 1.0
              A Morph  Distribution Kit,  a set  of files  that include the
              Morph program,  a set  of Professional  Draw clip files to be
              employed in the tutorial, installation command  files, a clip
              printout utility, and a copy of this manual.

          1.2 Organization
          This is a preliminary manual containing the tutorial excerpt from
          the Morph user manual. That manual is currently being written. 
          (Oct 1, 1989).















          Tutorial 
          The tutorial gives you lessons for using Morph  with Professional
          Draw.  Once  you  have  taken  the tutorial, you will know how to
          prepare Professional Draw clip files for  blending, how  to start
          the  Morph  program,  and  how  to incorporate the product of the
          Morph program into your Professional Draw artwork. 

          2.0 Tutorial
          2.1 Key Concepts
          2.2 First Blend
          2.3 Blending Summary
          2.4 Color Blending - Preliminary Remarks  

          2.1 Key Concepts
          What do blend tools do?
          Starting with a ``departure'' and ``destination'' pair of ``key''
          objects, a  blend tool adds a series of ``inbetween'' objects. On
          ``step'' one, the blend  tool first  copies the  departure object
          then transforms  the new  copy so  that it begins to resemble the
          destination  object.  the  blend   tool  continues   copying  and
          transforming objects  through the  remaining steps so that in the
          end, the last inbetween  object almost  resembles the destination
          object. For  example, if  the departure  object is a black-filled
          rectangle and the destination object is circular and  filled with
          white, an  inbetween object  in some  middle step  would be grey-
          filled and look somewhat like a rectangle with rounded corners. 

          What is Morph?
          Morph   emulates   Adobe   Illustrator's   blend   tool.   Unlike
          Illustrator's  blend  tool,  which  is  an  integral part of that
          program's drawing  desktop,  Morph  is  a  separate  program that
          operates in  an AmigaDOS  Command Line  Interpreter (CLI) window.
          Morph operates on clip files produced by Gold Disk's Professional
          Draw Version 1.0. 

          What does using Morph Entail?
          As a user of Morph, you would typically go through three steps:

          1.  Within Professional  Draw, creation  of at least one pair1 of
              key objects, turning it into a clip, saving the clip as file.

          2.  Within a CLI, starting  Morph,  first  naming  the  clip file
              created in  step one  for input  to Morph,  then naming a new
              file to hold Morph's output, finally specifying the number of
              inbetween objects  to use  in blending from one key object to
              the next. Your CLI command may look something like this:





               1 Advanced users  need not  restrict themselves  to pairs of
          key objects. see the Theory chapter.














          3
          Using Morph - Tutorial, Reference and Theory



              1> morph input.clips output.clips 40

              input.clips     -- the  name  of  your input file (created by
                              Professional Draw)
              output.clips    -- the  name  of  your  output  file  (to  be
                              created  by  Morph  and  used by Professional
                              Draw)
              40              -- the number of inbetween objects to  use in
                                blending from one key object to the next.

          3.  Within  Professional  Draw,  load  the output file created by
              Morph. Select the clips created by  Morph to  incorporate the
              blended objects into your drawing.
             
          2.2 First Blend
          Let's walk  through a morphing session to get a feel for this new
          tool. In this session, we'll take  a pre-made  clip file,  make a
          new  version  of  the  clip  file,  load  the  new clip file into
          Professional Draw  and observe  some blending  effects. to follow
          this procedure, you will need a copy of Professional Draw, Morph,
          and the file squarecircle.clip  that  came  with  the preliminary
          distribution.


          1.  Start a  CLI window  if you  don't have  one running already.
              Change your directory to where Morph is stored.

          2.  Start Professional Draw (optionally, create a page).

          Let's ensure that we have the proper tutorial file handy:

          3.  Within Professional Draw, select from the menu ``Clip: Load''
              Using  the   device  gadgets  and  directory  window,  direct
              Professional Draw to the where Morph is stored.

          4.  Select and load ``squarecircle.clip''

          5.  From Professional Draw's menu,  select ``Clip:  Draw. Pick   
              ``squaretocircle'' and draw it.

          You should see a square on your left and a circle on your right. 
          Lets try  blending from  the square to the circle. For this first
          blend we'll work with the squarecircle.clip  file already  on the
          disk. 

          6.  Bring the Workbench screen to front. Bring your CLI window to
              front and make it the active window. 

          7.  Start the Morph program by typing at the CLI prompt:















          4
          Using Morph - Tutorial, Reference and Theory


              1>morph squarecircle.clip newsquarecircle.clip 5

              Explanation:
              morph --                  the name of the blending program.

              squarecircle.clip --      the  Professional  Draw  clip  file
                                        we'd  loaded  and drawn with during
                                        steps 4-6. Now we are using this as
                                        an input file to Morph.

              newsquarecircle.clip --   a new  clip file  that will contain
                                        blended objects based  on  the clip
                                        stored   in  squarecircle.clip.  We
                                        need  not  name  this  output  file
                                        ``newsquarecircle.clip'',   but  it
                                        will  suffice  as  a  reference for
                                        this procedure.

              5 --                      the number of steps we want to have
                                        in our blend. In creating a blended
                                        clip,  Morph  will create this many
                                        objects  to  ``insert  in between''
                                        the two key objects.

          9.  Hit Return. In response, Morph should type words like this in
              the CLI window:

              This is Morph for Professional Draw. v 1.0.
              Copyright 1989 by Garry R. Osgood.
              Created: Sun Oct  1 19:39:12 1989

              Morphing clip squaretocircle with 2 key objects...Done.
              Inserted 5 inbetween objects between keys.
              Finished Morphing. Writing newsquarecircle.clip

          Morph's startup banner  consists  of  three  lines,  its  name, a
          copyright notice,  and a  compilation date.  You should check the
          compilation date you actually get when you run your copy of Morph
          against the  date cited  in this manual. If there is a difference
          of greater than six months, check for a  revision announcement or
          updated  documentation  --  Morph  may  have acquired features or
          obtained bug fixes not covered in this manual. 

          Morph reports  its  processing  efforts  in  the  three following
          lines.   In    this   example,   Morph   found   a   clip   named
          ``squaretocircle'' that held two  key objects  -- the  square and
          circle. ``...Done''  means Morph  had no  trouble deciding how to
          blend from one key  object to  the next.  Morph created  five new
          ``inbetween''  objects  to  express  the  transition from one key
          object to the next.  This is  in line  with our  request. Finally
          Morph wrote  a new  clip file, newsquarecircle.clip, to store the














          5
          Using Morph - Tutorial, Reference and Theory


          newly-blended clip.

          Errors   can   happen.   When   errors   occur,   Morph   reports
          ``...Problem''  instead  of  ``...Done''.    For  example, had we
          created the clip  squaretocircle  with  only  the  square object,
          Morph would have reported: 

            Morphing clip squaretocircle with 1 key objects...Problem.
            I can't morph if I only have one key object.
            Sorry, Morph failed.

          In rule format:

          Rule 1:   Rule of  Keys: Morph  needs at least two key objects to
                    make a blend.

          Morph sometimes can't decide  how to  blend between  two objects,
          another  source  of  error  messages.  This indecision stems from
          certain limitations in this release  of  Morph:  it  cannot blend
          between  structually  distinct  objects.  In  Professional Draw's
          domain, Bezier objects, Grids  and Ellipses  are all structurally
          distinct  from  one  another.  Professional  Draw  uses different
          procedures to  draw each  type of  object and,  as a consequence,
          each type  of object  has different internal representations. For
          example, a center point, a minimum  axis, a  maximum axis,  and a
          rotation about the center point comprise the items of information
          that go into the  description of  an elliptic  object. To  make a
          drawing, Professional  Draw ``plugs'' these data into the formula
          for an ellipse. On the  other  hand,  Bezier  objects  consist of
          arrays of  control point locations and are ``plugged'' into cubic
          parametric equations.  This  array  of  control  points  does not
          compare with elliptic objects' center points, minimum and maximum
          axes, or rotation angles. A similiar  mis-match in representation
          prevails between  Ellipses and  Grids. Thus,  attempting to blend
          from an Ellipse to a Grid  (stored in  a clip  called ovaltogrid)
          will cause Morph to report: 

            Morphing clip ovaltogrid with 2 key objects...Problem.
            I don't know how to morph between different object types.
            Sorry, Morph failed.

          Beziers made  with differing  numbers of  control points are also
          structurally   distinct   and,   in   this   release   of  Morph,
          unblendable.  These  so-called  mis-matched  Bezier objects cause
          Morph to report: 

            Morphing clip mismatch with 2 key objects...Problem.
            I don't  know  how  to  morph  between  Beziers  with differing
            numbers of control points.
            Sorry, Morph failed.















          6
          Using Morph - Tutorial, Reference and Theory


          Let's establish rules stating these limitations succinctly:

          Rule 2:   Law  of  Types:  Morph  only  blends  objects with like
                    types.

          Rule 2a:  Law of Bezier Control Points: Morph  only blends Bezier
                    objects comprised of equal numbers of control points. 

          Astute readers may wonder how the square and circle in our sample
          clip file squarecircle.clip can be morphed without violating Rule
          2;  in  Professional  Draw,  aren't  squares  Bezier  objects and
          circles  specialized  ellipses?  Circles  usually  are  made with
          elliptic objects,  but they can be emulated with Bezier objects2.
          In squaretocircle.clip, the absense of a central control point in
          the ``circle''  gives away  the fact  that the circle is a Bezier
          object constructed out of  the same  number of  control points as
          the square (four).

          Once   Morph   has   made  `newsquarecircle.clip'  we  return  to
          Professional Draw to inspect  how the  blend between  the two key
          objects in the clip turned out. 

          10. Bring   the   Professional   Draw  screen  to  front.  Within
              Professional Draw, select Clip: Load. Change  to the tutorial
              directory, if necessary, and load `newsquarecircle.clip'.

          11. Select Clip:  Draw. In  the clip  directory, you should see a
              new clip %-squaretocircle in addition to  squaretocircle. the
              ``%-'' prefix  reminds us that squaretocircle is a ``parent''
              of this clip. Select it; position the clip and draw it.

          We now should have a series of objects. Going from left to right,
          the objects  go from square to round, corners disappearing, sides
          bulging out. Congratulations, you have now blended two objects. 



               2In the author's opinion, ``Bezier'' circles are a good deal
          more useful  than native  ellipses. They may be disassembled into
          arcs, they  may be  distorted in  ways far  more interesting than
          what prevails  with native  ellipses, and  so forth. True, Bezier
          circles (and ellipses) may never be exactly circles  or ellipses,
          but  they  can  be  made  to approximate the conic sections to an
          arbitrarily close  degree of  precision. Similar  reasoning is in
          force  with  grids;  the  author  rarely  uses  them in his work.
          Agreed,  making  Bezier  imitations   are   tricky.   The  artist
          ``constructs'' a  Bezier on  top of an ellipse (or grid), serving
          as a template. Conversion is possible,  and the  presence of such
          conversion routines  in future creations of Morph would eliminate
          the restrictive Law of  Types and  (with some  more work)  Law of
          Bezier Control Points. 














          7
          Using Morph - Tutorial, Reference and Theory


          From this  point onward,  you can  do anything you wish with this
          clip:  ungroup  it,  move  the  components   around,  change  the
          individual  objects.  Morph  generated  clips are the same as any
          other clips made with Professional Draw.

          Assuming  that  we've  been  successful  so  far,  lets  make  an
          important observation  about the  square and circle: First, if we
          check the front-to-back relationship  between the  initial square
          and  the  final  circle,  we'll  see that the square is ``layered
          behind'' the circle. Front to back relationships are important to
          Morph because  this program  always picks  the rearmost object to
          start blending from,  and  blends  toward  the  frontmost object.
          Let's state this as a third rule:

          Rule 3:   Blending  order:  Morph  blends  from  the rearmost key
                    object to the frontmost key object.

          2.3 Blending summary
          Our first blend was untypical in  that we  started with  a canned
          clip and  blended it  -- a useful experience in that we were able
          to walk through the mechanics of operating Morph,  deriving three
          working  rules  in  the  process,  but not like a typical working
          session.

          In a  typical Professional  Draw/Morph working  session you might
          set up  a pair  of key objects by duplicating some object already
          in your drawing, then modifying  the  copy  object  in  some way.
          Finally, you  would employ  Morph to blend between the two, using
          the new clip to achieve some  step-like effect  in your  work. In
          detail, you would:

              Select an object, and 
              Make a duplicate of it by hitting the TAB key. Then
              Modify the duplicate. 
              Include the original object in an aggregate with the modified
              object by shift-selecting it.
              Define the aggregate as a clip.
              Save the clip file.
              Blend the clip file using the procedure in ``First Blend.''
              Load the blended version of the clip file and use the blended
              version in your drawing.

          Morph has other features that come in handy after you've had some
          practice.

              Morph accepts clips with more than two key  objects -- middle
              key objects  act like  key objects  just as key frames act in
              animation,

              Morph  accepts  clip  files  with  more  than  one  clip.  It
              processes all clips independently of one another. This serves














          8
          Using Morph - Tutorial, Reference and Theory


              as a way to batch blends together.

          2.4 Color Morphing - Preliminary Remarks

          Morph blends  colors  as  well  as  line  attributes  and shapes.
          Theoretically,  you   can  work   with  the  1.6  million  colors
          Professional Draw ``supports'',  but  the  limitation  of Amiga's
          high resolution  color palette  certainly compromises our ability
          to make informed judgements when drawing with more than the seven
          additional  colors  beyond  the  nine-step  grey scale built into
          Professional Draw.  This tutorial  investigates the possibilities
          and limitations of color morphing.

          1.  Load the clipfile squarecircle.clip; draw it.

          2.  Ungroup the objects. 
          3.  Set line weights for both objects to zero; 
          4.  Fill the  square and circle with different colors. Do not use
              gray scale colors for at least  one of  the objects;  in this
              tutorial, we are stretching Professional Draw/Amiga's display
              capabilities to the limit. 
          5.  Morph what you've got using five steps.

          You should have a  pretty rainbow  effect, especially  if you had
          picked both colors from the list. 

          Morph  ascribes  to  the  R-G-B  Color  Cube  model when blending
          colors; it decomposes source  and  destination  colors  into red,
          green, and  blue components  and then  adds the components. Thus,
          blending complements (i.e. red to cyan,  green to  magenta,  blue
          to  yellow,  or  white  to  black  and  vice  versa)  ``brings us
          through'' the center of the color cube; colors tend to grey, then
          to  the  complement.  More  colorful  blends  may  be obtained by
          avoiding the middle  of  the  cube,  i.e.  morphing  from  red to
          magenta, yellow to green. 

          Since Morph  creates colors, we should visit the Fill Color List.
          Select Color: Fill Color.  Note that  new patches  have appeared.
          While vaugely  mathematical in appearance, the patch names follow
          this convention:

            C<cccc>-M<mmmm>-Y<yyyy>

            <cccc>  an up-to-four digit  number  expressing  the  amount of
                    cyan pigment.
            
            <mmmm>  a  up-to-four  digit  number  expressing  the amount of
                    magenta pigment.

            <yyyy>  a up-to-four  digit  number  expressing  the  amount of
                    yellow pigment.














          9
          Using Morph - Tutorial, Reference and Theory



          This   naming   style   follows  subtractive  color  conventions,
          appropriate  for  laying  ink   on  paper.   This  convention  is
          appropriate since  most Professional  Draw renderings will employ
          subtractive pigments to modify white light. 

          Professional Draw scales pigment  from  0  (no  pigment)  to 1023
          (maximum  pigment).  Thus  C1023-M1023-Y1023  is  another  way to
          express black; C1023-M1023-Y0 represents blue, and C511-M511-Y511
          represents middle  grey. This scheme supports 1024 * 1024 * 1024,
          or 1,073,741,824 colors. The full expression  of this  palette is
          far beyond  Amiga's high resolution mode color capability; Of the
          sixteen color Amiga high  resolution  palette,  Professional Draw
          lends you  seven ``spares''  beyond the nine gray scale colors it
          allocates at the outset. But if your drawing technique depends on
          the expression  of many  different colors,  Professional Draw and
          Morph can only support your style  internally;   the ``WYSISWYG''
          preview  mode  of  Professional  Draw cannot, because of hardware
          limitations, lend you much visual support.3 To get a sense of the
          limitation, morph  your colored  version of squaretocircle again,
          but use thirty or forty steps.  

          As you may see, starting from  the eight  new color, Professional
          Draw  substitutes  black  for  new  colors.  If  you have blended
          several times using different color octaves, the majority of them
          will  be  poorly  represented  in  the  ``WYSIWYG'' mode. In some
          cases, switching to a black-and-white WYSISYG mode will  give you


               3There are  few remedies  for artists wishing to have TRUELY
          representative displays. In terms of expense they run from:

            1.      Placing Professional  Draw  into  black-and-white mode;
                    the mezzotinting effect at least reflects a gray scale

            2.      Print a  proof on a black-and-white PostScript printer.
                    As above, but at a higher resolution and somewhat wider
                    latitude

            3.      Proof  on  a  Color  PostScript  printer,  an expensive
                    purchace  or  an  inconvenient  wait  while  your local
                    output service delivers

            4.      Color separate and have proofs made

            5.      Migrate to a Mac II.

            6.      Migrate to a UNIX workstation

          The author  presents the  last two  alternatives only somewhat in
          jest.














          10
          Using Morph - Tutorial, Reference and Theory


          a more telling representation of your drawing.

























































